%visualisation de fichier msh P1-2D
nomfic='fissure2.msh';
fid=fopen(nomfic);
line=fgetl(fid);
line=fgetl(fid);
line=fgetl(fid);
line=fgetl(fid);
nbd=fscanf(fid,'%i',1);
nomdom=cell(nbd,1);
for i=1:nbd,
    nudom(i)=fscanf(fid,'%i',1);
    nom=fscanf(fid,'%s',1);
    nom=regexprep(nom,'"','');
    nomdom{i,1}=nom;   
end,
line=fgetl(fid);line=fgetl(fid);
line=fgetl(fid);

nbnode=fscanf(fid,'%i',1);
node=zeros(nbnode,3);
for i=1:nbnode
   n=fscanf(fid,'%i',1);
   nodes(n,:)=fscanf(fid,'%g',3);
end,
line=fgetl(fid);line=fgetl(fid);  
line=fgetl(fid);

nbelt=fscanf(fid,'%i',1);
numelt=zeros(nbelt,3);
typelt=zeros(nbelt,1);
domelt=zeros(nbelt,1);
for k=1:nbelt,
    n=fscanf(fid,'%i',1);            %num elt
    typelt(n)=fscanf(fid,'%i',1);    %type elt (1=segment,2=triangle)
    nt=fscanf(fid,'%i',1);           %nbtag (3 en gnral)
    tags=fscanf(fid,'%i',nt);        %tags : num domaine, num geomtrie, num partition 
    domelt(n)=tags(1);
    if(typelt(n)==1) numelt(n,1:2)=fscanf(fid,'%i',2);end,
    if(typelt(n)==2) numelt(n,:)=fscanf(fid,'%i',3);end,
    fgetl(fid);
end,
fclose(fid);

colors=[1 0 0; 0 1 0; 0 0 1; 1 .5 .5;.5 1 .5;.5 .5 1];
%dessin
figure;hold on;
for n=1:nbelt,
    if(typelt(n)==2)  %dessine triangle
        X=[nodes(numelt(n,1),1) nodes(numelt(n,2),1) nodes(numelt(n,3),1)]; 
        Y=[nodes(numelt(n,1),2) nodes(numelt(n,2),2) nodes(numelt(n,3),2)]; 
        fill(X,Y,colors(domelt(n),:));
        gx=sum(X)/3.;gy=sum(Y)/3.;
        text(gx,gy,num2str(n),'VerticalAlignment','middle','HorizontalAlignment','center')
    end, 
    if(typelt(n)==1)  %dessine segment
        X=[nodes(numelt(n,1),1) nodes(numelt(n,2),1)]; 
        Y=[nodes(numelt(n,1),2) nodes(numelt(n,2),2)]; 
        Z=[0.01 0.01];
        plot3(X,Y,Z,'Color',colors(domelt(n),:)','LineWidth',2);
    end,  
end,
for i=1:nbnode,
    text(nodes(i,1),nodes(i,2),num2str(i),'VerticalAlignment','middle','HorizontalAlignment','center','BackGroundColor','w');
end,
y=0.90;
for i=1:nbd,
    x=0.01;
    annotation('rectangle',[x y 0.02 0.01],'EdgeColor',colors(i,:),'FaceColor',colors(i,:));
    annotation('textbox',[x+0.02 y 0.02 0.01],'String',nomdom(i),'VerticalAlignment','Middle','EdgeColor','none');
    y=y-.02;
end,
title({[nomfic ' (' num2str(nbelt) ' lments, ' num2str(nbnode) ' noeuds)'];' '});


